Package org.apache.velocity.util.introspection

# Class ClassMap

java.lang.Object
org.apache.velocity.util.introspection.ClassMap

public class ClassMap extends Object
A cache of introspection information for a specific class instance. Keys `Method` objects by a concatenation of the method name and the names of classes that make up the parameters.

Version:
  $Id$
Author:
  Jason van Zyl, Bob McWhirter, Attila Szegedi, Geir Magnusson Jr., Henning P. Schmiedehausen, Nathan Bubna, Claude Brisson

## Constructor Summary

Constructors
Constructor
Description
`ClassMap(Class<?> clazz, org.slf4j.Logger log)`
Standard constructor
`ClassMap(Class<?> clazz, org.slf4j.Logger log, TypeConversionHandler conversionHandler)`
Standard constructor

## Method Summary

Modifier and Type
Method
Description
`Method`
`findMethod(String name, Object[] params)`
Find a Method using the method name and parameter objects.
`Class<?>`
`getCachedClass()`
Returns the class object whose methods are cached by this map.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ClassMap

public ClassMap(Class<?> clazz, org.slf4j.Logger log)
Standard constructor

Parameters:
  `clazz` - The class for which this ClassMap gets constructed.
  `log` - logger

### ClassMap

public ClassMap(Class<?> clazz, org.slf4j.Logger log, TypeConversionHandler conversionHandler)
Standard constructor

Parameters:
  `clazz` - The class for which this ClassMap gets constructed.
  `log` - logger
  `conversionHandler` - conversion handler
Since:
  2.0

## Method Details

### getCachedClass

public Class<?> getCachedClass()
Returns the class object whose methods are cached by this map.

Returns:
  The class object whose methods are cached by this map.

### findMethod

public Method findMethod(String name, Object[] params) throws MethodMap.AmbiguousException
Find a Method using the method name and parameter objects.

Parameters:
  `name` - The method name to look up.
  `params` - An array of parameters for the method.
Returns:
  A Method object representing the method to invoke or null.
Throws:
  `MethodMap.AmbiguousException` - When more than one method is a match for the parameters.